import bpy
from bpy.props import (BoolProperty, FloatProperty, IntProperty)


# Quick Playblast 1080 -------------------------------------------------------

class OBJECT_OT_quick_playblast_1080_animbox_ra(bpy.types.Operator):
    '''Quick Playblast 1080'''
    bl_idname = "object.quick_playblast_1080_animbox_ra"
    bl_label = "Playblast 1080"
    bl_options = {'REGISTER', 'UNDO'}


    def execute(self, context):
        
        plus_audio = context.scene.quick_playblast_audio_abox_ra

        path = bpy.context.scene.render.filepath

        path_string = ''

        if path != path_string:

            bpy.context.scene.render.resolution_x = 1920
            bpy.context.scene.render.resolution_y = 1080
            
            bpy.context.scene.render.image_settings.file_format = 'FFMPEG'
            bpy.context.scene.render.ffmpeg.format = 'MPEG4'

            bpy.context.scene.render.ffmpeg.codec = 'H264'
            bpy.context.scene.render.ffmpeg.constant_rate_factor = 'MEDIUM'
            
            if plus_audio:
                bpy.context.scene.render.ffmpeg.audio_codec = 'MP3'    

            # Viewport_Render
            bpy.ops.render.opengl('INVOKE_DEFAULT',animation=True) 


        return {'FINISHED'}



# Quick Playblast 720 -------------------------------------------------------

class OBJECT_OT_quick_playblast_720_animbox_ra(bpy.types.Operator):
    '''Quick Playblast 720'''
    bl_idname = "object.quick_playblast_720_animbox_ra"
    bl_label = "Playblast 720"
    bl_options = {'REGISTER', 'UNDO'}


    def execute(self, context):
        
        plus_audio = context.scene.quick_playblast_audio_abox_ra
 
        path = bpy.context.scene.render.filepath

        path_string = ''


        if path != path_string:

            bpy.context.scene.render.resolution_x = 1280
            bpy.context.scene.render.resolution_y = 720
            
            bpy.context.scene.render.image_settings.file_format = 'FFMPEG'
            bpy.context.scene.render.ffmpeg.format = 'MPEG4'

            bpy.context.scene.render.ffmpeg.codec = 'H264'
            bpy.context.scene.render.ffmpeg.constant_rate_factor = 'MEDIUM'

            if plus_audio:
                bpy.context.scene.render.ffmpeg.audio_codec = 'MP3'
                

            # Viewport_Render 
            bpy.ops.render.opengl('INVOKE_DEFAULT',animation=True)



        return {'FINISHED'}



# Quick Playblast 480 -------------------------------------------------------

class OBJECT_OT_quick_playblast_480_animbox_ra(bpy.types.Operator):
    '''Quick Playblast 480'''
    bl_idname = "object.quick_playblast_480_animbox_ra"
    bl_label = "Playblast 480"
    bl_options = {'REGISTER', 'UNDO'}

    def execute(self, context):
        
        plus_audio = context.scene.quick_playblast_audio_abox_ra

        path = bpy.context.scene.render.filepath

        path_string = ''


        if path != path_string:

            bpy.context.scene.render.resolution_x = 720
            bpy.context.scene.render.resolution_y = 480
            
            bpy.context.scene.render.image_settings.file_format = 'FFMPEG'
            bpy.context.scene.render.ffmpeg.format = 'MPEG4'

            bpy.context.scene.render.ffmpeg.codec = 'H264'
            bpy.context.scene.render.ffmpeg.constant_rate_factor = 'MEDIUM'
            
            if plus_audio:
                bpy.context.scene.render.ffmpeg.audio_codec = 'MP3'
                            
            # Viewport_Render 
            bpy.ops.render.opengl('INVOKE_DEFAULT',animation=True)



        return {'FINISHED'}


#---------------------------------------------------------------------------


classes = [ OBJECT_OT_quick_playblast_1080_animbox_ra,
            OBJECT_OT_quick_playblast_720_animbox_ra,
            OBJECT_OT_quick_playblast_480_animbox_ra,
            
          ]
 
 
 
def register():
    for cls in classes:
        bpy.utils.register_class(cls)
        

    bpy.types.Scene.quick_playblast_audio_abox_ra = bpy.props.BoolProperty(
        name="Audio",
        description="Playblast with Audio",
        default = False,
    )


 
def unregister():
    for cls in classes:
        bpy.utils.unregister_class(cls)

    del bpy.types.Scene.quick_playblast_audio_abox_ra
 
 
if __name__ == "__main__":
    register() 